| Flutter Impeller |

Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
impeller::Contents Class Referenceabstract

`#include <contents.h>`

Inheritance diagram for impeller::Contents:

## Classes
struct | StencilCoverage

## Public Types
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>

## Public Member Functions
| Contents ()
virtual | ~Contents ()
virtual void | PopulateGlyphAtlas (const std::shared_ptr< LazyGlyphAtlas > &lazy_glyph_atlas, Scalar scale)
| Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text. More...
virtual bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const =0
virtual std::optional< Rect > | GetCoverage (const Entity &entity) const =0
| Get the screen space bounding rectangle that this contents affects. More...
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque () const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual StencilCoverage | GetStencilCoverage (const Entity &entity, const std::optional< Rect > &current_stencil_coverage) const
| Given the current screen space bounding rectangle of the stencil, return the expected stencil coverage after this draw call. This should only be implemented for contents that may write to the stencil buffer. More...
virtual std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, const std::string &label="Snapshot") const
| Render this contents to a snapshot, respecting the entity's transform, path, stencil depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
virtual bool | ShouldRender (const Entity &entity, const std::optional< Rect > &stencil_coverage) const
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual bool | CanInheritOpacity (const Entity &entity) const
| Whether or not this contents can accept the opacity peephole optimization. More...
virtual void | SetInheritedOpacity (Scalar opacity)
| Inherit the provided opacity. More...
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual const FilterContents * | AsFilter () const
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Static Public Member Functions
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Definition at line 33 of file contents.h.

## Member Typedef Documentation

## ◆ ColorFilterProc

using impeller::Contents::ColorFilterProc = std::function<Color(Color)>

A procedure that filters a given unpremultiplied color to produce a new unpremultiplied color.

Definition at line 37 of file contents.h.

## ◆ CoverageProc

using impeller::Contents::CoverageProc = std::function<std::optional<Rect>(const Entity& entity)>

Definition at line 49 of file contents.h.

## ◆ RenderProc

using impeller::Contents::RenderProc = std::function<bool(const ContentContext& renderer, const Entity& entity, RenderPass& pass)>

Definition at line 48 of file contents.h.

## Constructor & Destructor Documentation

## ◆ Contents()

impeller::Contents::Contents | ( |  | ) |
| default

## ◆ ~Contents()

impeller::Contents::~Contents | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ ApplyColorFilter()

bool impeller::Contents::ApplyColorFilter | ( | const ColorFilterProc & | color_filter_proc | ) |
| virtual

If possible, applies a color filter to this contents inputs on the CPU.

This method will either fully apply the color filter or perform no action. Partial/incorrect application of the color filter will never occur.

Parameters

  [in] | color_filter_proc | A function that filters a given unpremultiplied color to produce a new unpremultiplied color.

Returns
  True if the color filter was able to be fully applied to all all relevant inputs. Otherwise, this operation is a no-op and false is returned.

Reimplemented in impeller::SolidColorContents, impeller::SolidRRectBlurContents, impeller::LinearGradientContents, impeller::SweepGradientContents, impeller::RadialGradientContents, and impeller::ConicalGradientContents.

Definition at line 130 of file contents.cc.

131 {
132 return false;
133 }

## ◆ AsBackgroundColor()

std::optional< Color > impeller::Contents::AsBackgroundColor | ( | const Entity & | entity,
|  | ISize | target_size
| ) |  | const
| virtual

Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation.

This is useful for absorbing full screen solid color draws into subpass clear colors.

Reimplemented in impeller::SolidColorContents.

Definition at line 121 of file contents.cc.

122 {
123 return {};
124 }

## ◆ AsFilter()

const FilterContents * impeller::Contents::AsFilter | ( |  | ) | const
| virtual

Cast to a filter. Returns `nullptr` if this Contents is not a filter.

Reimplemented in impeller::FilterContents.

Definition at line 126 of file contents.cc.

126 {
127 return nullptr;
128 }

## ◆ CanInheritOpacity()

bool impeller::Contents::CanInheritOpacity | ( | const Entity & | entity | ) | const
| virtual

Whether or not this contents can accept the opacity peephole optimization.

By default all contents return false. Contents are responsible for determining whether or not their own geometries intersect in a way that makes accepting opacity impossible. It is always safe to return false, especially if computing overlap would be computationally expensive.

Reimplemented in impeller::ColorSourceContents, impeller::ClipRestoreContents, impeller::TextureContents, impeller::ClipContents, impeller::TextContents, and impeller::RuntimeEffectContents.

Definition at line 112 of file contents.cc.

112 {
113 return false;
114 }

## ◆ GetColorSourceSize()

std::optional< Size > impeller::Contents::GetColorSourceSize | ( |  | ) | const

Return the color source's intrinsic size, if available.

        For example, a gradient has a size based on its end and beginning
        points, ignoring any tiling. Solid colors and runtime effects have
        no size.

Definition at line 159 of file contents.cc.

159 {
160 return color_source_size_;
161 };

## ◆ GetCoverage()

virtual std::optional<Rect> impeller::Contents::GetCoverage | ( | const Entity & | entity | ) | const
| pure virtual

Get the screen space bounding rectangle that this contents affects.

Implemented in impeller::AtlasColorContents, impeller::FilterContents, impeller::AtlasTextureContents, impeller::ColorSourceContents, impeller::VerticesUVContents, impeller::AtlasContents, impeller::ClipRestoreContents, impeller::VerticesColorContents, impeller::TextureContents, impeller::TextContents, impeller::SolidColorContents, impeller::VerticesContents, impeller::SolidRRectBlurContents, impeller::AnonymousContents, impeller::ClipContents, and impeller::CheckerboardContents.

Referenced by RenderToSnapshot(), and ShouldRender().

## ◆ GetCoverageHint()

const std::optional< Rect > & impeller::Contents::GetCoverageHint | ( |  | ) | const

Definition at line 155 of file contents.cc.

155 {
156 return coverage_hint_;
157 }

Referenced by impeller::VerticesContents::Render(), impeller::VerticesUVContents::Render(), and impeller::FilterContents::Render().

## ◆ GetStencilCoverage()

Contents::StencilCoverage impeller::Contents::GetStencilCoverage | ( | const Entity & | entity,
|  | const std::optional< Rect > & | current_stencil_coverage
| ) |  | const
| virtual

Given the current screen space bounding rectangle of the stencil, return the expected stencil coverage after this draw call. This should only be implemented for contents that may write to the stencil buffer.

Reimplemented in impeller::ClipRestoreContents, and impeller::ClipContents.

Definition at line 52 of file contents.cc.

54 {
55 return {.type = StencilCoverage::Type::kNoChange,
56 .coverage = current_stencil_coverage};
57 }

References impeller::Contents::StencilCoverage::kNoChange, and impeller::Contents::StencilCoverage::type.

## ◆ IsOpaque()

bool impeller::Contents::IsOpaque | ( |  | ) | const
| virtual

Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity.

Reimplemented in impeller::SolidColorContents, impeller::TiledTextureContents, impeller::LinearGradientContents, impeller::SweepGradientContents, and impeller::RadialGradientContents.

Definition at line 48 of file contents.cc.

48 {
49 return false;
50 }

Referenced by impeller::testing::TEST_P().

## ◆ MakeAnonymous()

std::shared_ptr< Contents > impeller::Contents::MakeAnonymous | ( | Contents::RenderProc | render_proc,
|  | Contents::CoverageProc | coverage_proc
| ) |  |
| static

Definition at line 37 of file contents.cc.

39 {
40 return AnonymousContents::Make(std::move(render_proc),
41 std::move(coverage_proc));
42 }

References impeller::AnonymousContents::Make().

## ◆ PopulateGlyphAtlas()

virtual void impeller::Contents::PopulateGlyphAtlas | ( | const std::shared_ptr< LazyGlyphAtlas > & | lazy_glyph_atlas,
|  | Scalar | scale
| ) |  |
| inline virtual

Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text.

Reimplemented in impeller::FilterContents, and impeller::TextContents.

Definition at line 60 of file contents.h.

62 {}

## ◆ Render()

virtual bool impeller::Contents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| pure virtual

Implemented in impeller::AtlasColorContents, impeller::FilterContents, impeller::AtlasTextureContents, impeller::VerticesUVContents, impeller::ClipRestoreContents, impeller::AtlasContents, impeller::VerticesColorContents, impeller::TextureContents, impeller::TextContents, impeller::SolidColorContents, impeller::VerticesContents, impeller::SolidRRectBlurContents, impeller::ClipContents, impeller::RuntimeEffectContents, impeller::TiledTextureContents, impeller::LinearGradientContents, impeller::SceneContents, impeller::SweepGradientContents, impeller::RadialGradientContents, impeller::ConicalGradientContents, impeller::AnonymousContents, and impeller::CheckerboardContents.

## ◆ RenderToSnapshot()

std::optional< Snapshot > impeller::Contents::RenderToSnapshot | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | std::optional< Rect > | coverage_limit = `std::nullopt`,
|  | const std::optional< SamplerDescriptor > & | sampler_descriptor = `std::nullopt`,
|  | bool | msaa_enabled = `true`,
|  | const std::string & | label = `"Snapshot"`
| ) |  | const
| virtual

Render this contents to a snapshot, respecting the entity's transform, path, stencil depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`.

Reimplemented in impeller::TiledTextureContents, impeller::TextureContents, and impeller::FilterContents.

Definition at line 59 of file contents.cc.

65 {
66 auto coverage = GetCoverage(entity);
67 if (!coverage.has_value()) {
68 return std::nullopt;
69 }
70
71 // Pad Contents snapshots with 1 pixel borders to ensure correct sampling
72 // behavior. Not doing so results in a coverage leak for filters that support
73 // customizing the input sampling mode. Snapshots of contents should be
74 // theoretically treated as infinite size just like layers.
75 coverage = coverage->Expand(1);
76
77 if (coverage_limit.has_value()) {
78 coverage = coverage->Intersection(*coverage_limit);
79 if (!coverage.has_value()) {
80 return std::nullopt;
81 }
82 }
83
84 auto texture = renderer.MakeSubpass(
85 label, ISize::Ceil(coverage->size),
86 [&contents = *this, &entity, &coverage](const ContentContext& renderer,
87 RenderPass& pass) -> bool {
88 Entity sub_entity;
89 sub_entity.SetBlendMode(BlendMode::kSourceOver);
90 sub_entity.SetTransformation(
91 Matrix::MakeTranslation(Vector3(-coverage->origin)) *
92 entity.GetTransformation());
93 return contents.Render(renderer, sub_entity, pass);
94 },
95 msaa_enabled);
96
97 if (!texture) {
98 return std::nullopt;
99 }
100
101 auto snapshot = Snapshot{
102 .texture = texture,
103 .transform = Matrix::MakeTranslation(coverage->origin),
104 };
105 if (sampler_descriptor.has_value()) {
106 snapshot.sampler_descriptor = sampler_descriptor.value();
107 }
108
109 return snapshot;
110 }

References impeller::TSize< int64_t >::Ceil(), GetCoverage(), impeller::ContentContext::MakeSubpass(), impeller::Matrix::MakeTranslation(), and impeller::Snapshot::texture.

Referenced by impeller::TextureContents::RenderToSnapshot(), and impeller::TiledTextureContents::RenderToSnapshot().

## ◆ SetColorSourceSize()

void impeller::Contents::SetColorSourceSize | ( | Size | size | ) |

Definition at line 163 of file contents.cc.

163 {
164 color_source_size_ = size;
165 }

## ◆ SetCoverageHint()

void impeller::Contents::SetCoverageHint | ( | std::optional< Rect > | coverage_hint | ) |

Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`.

Definition at line 151 of file contents.cc.

151 {
152 coverage_hint_ = coverage_hint;
153 }

## ◆ SetInheritedOpacity()

void impeller::Contents::SetInheritedOpacity | ( | Scalar | opacity | ) |
| virtual

Inherit the provided opacity.

       Use of this method is invalid if CanAcceptOpacity returns false.

Reimplemented in impeller::ColorSourceContents, impeller::ClipRestoreContents, impeller::TextureContents, impeller::ClipContents, and impeller::TextContents.

Definition at line 116 of file contents.cc.

116 {
117 VALIDATION_LOG << "Contents::SetInheritedOpacity should never be called when "
118 "Contents::CanAcceptOpacity returns false.";
119 }

References VALIDATION_LOG.

## ◆ ShouldRender()

bool impeller::Contents::ShouldRender | ( | const Entity & | entity,
|  | const std::optional< Rect > & | stencil_coverage
| ) |  | const
| virtual

Reimplemented in impeller::ClipRestoreContents, and impeller::ClipContents.

Definition at line 135 of file contents.cc.

136 {
137 if (!stencil_coverage.has_value()) {
138 return false;
139 }
140
141 auto coverage = GetCoverage(entity);
142 if (!coverage.has_value()) {
143 return false;
144 }
145 if (coverage == Rect::MakeMaximum()) {
146 return true;
147 }
148 return stencil_coverage->IntersectsWithRect(coverage.value());
149 }

References GetCoverage(), and impeller::TRect< Scalar >::MakeMaximum().

The documentation for this class was generated from the following files:

- impeller/entity/contents/contents.h
- impeller/entity/contents/contents.cc

impeller::Contents::GetCoverage
virtual std::optional< Rect > GetCoverage(const Entity &entity) const =0
Get the screen space bounding rectangle that this contents affects.
impeller::TSize< int64_t >::Ceil
constexpr TSize Ceil() const
Definition: size.h:91
impeller::Contents::StencilCoverage::Type::kNoChange
@ kNoChange
impeller::Matrix::MakeTranslation
static constexpr Matrix MakeTranslation(const Vector3 &t)
Definition: matrix.h:94
VALIDATION_LOG
#define VALIDATION_LOG
Definition: validation.h:60
impeller::TRect< Scalar >::MakeMaximum
constexpr static TRect MakeMaximum()
Definition: rect.h:75
impeller::AnonymousContents::Make
static std::shared_ptr< Contents > Make(RenderProc render_proc, CoverageProc coverage_proc)
Definition: anonymous_contents.cc:11